package org.firstinspires.ftc.teamcode.subsystem;

import static org.firstinspires.ftc.teamcode.PedroConstants.HOOK;
import static org.firstinspires.ftc.teamcode.PedroConstants.LIFT_SLIDE_LEFT_MOTOR;
import static org.firstinspires.ftc.teamcode.PedroConstants.LIFT_SLIDE_RIGHT_MOTOR;

import com.qualcomm.robotcore.hardware.DcMotor;
import com.qualcomm.robotcore.hardware.DcMotorEx;
import com.qualcomm.robotcore.hardware.DcMotorSimple;
import com.qualcomm.robotcore.hardware.HardwareMap;
import static org.firstinspires.ftc.teamcode.configs.RobotConstants.toBar;
import static org.firstinspires.ftc.teamcode.configs.RobotConstants.toFloor;

public class HangMotorSubsystem {
    private DcMotorEx hang;

    public HangMotorSubsystem(HardwareMap hardwareMap) {
        hang = hardwareMap.get(DcMotorEx.class, HOOK);
    }

    public int getCurrentPosition(){
        int Return = hang.getCurrentPosition();
        return Return;
    }
    public void init(){
        hang.setMode(DcMotor.RunMode.STOP_AND_RESET_ENCODER);
        hang.setDirection(DcMotorSimple.Direction.FORWARD);
        hang.setZeroPowerBehavior(DcMotor.ZeroPowerBehavior.BRAKE);
        hang.setMode(DcMotor.RunMode.RUN_USING_ENCODER);

    }
    public void hangRobot(){
        hang.setMode(DcMotor.RunMode.RUN_TO_POSITION);
        hang.setTargetPosition(toBar);
        while(hang.isBusy()){
            hang.setPower(1);
        }
    }
    public void robotToFloor(){
        hang.setTargetPosition(toFloor);
    }
    public void disableMotor(){
        hang.setPower(0);

    }
    public void setPower(double power){
        hang.setPower(power);
    }
    public void stopMotor(){
        hang.setPower(0);


    }
    public void toHangPosition(int Position){
        //write in limits for protection
        hang.setPower(Position);
    }
    public void setPower(boolean forward, double power){
        if(forward)
        hang.setDirection(DcMotorSimple.Direction.FORWARD);
        else if(!forward)
            hang.setDirection(DcMotorSimple.Direction.REVERSE);
        hang.setPower(power);
    }

}
